#!/bin/bash

update=/mnt/hda3/.landisk-update
local=/mnt/hda3/local

led=/usr/local/bin/ledcont

finalize() {
  # remove archives
  rm -f $update/update.tgz
  rm -f $update/update-files.tar.gz

  # sync disk
  sync
  sync

  # remount read only
  mount -o remount,ro %root% /
}

# error exit
error_exit() {
  finalize
  # warning
  $led cycle 8
  sleep 1
  $led acchw
  exit 1
}

# LED blink start
$led cycle 30
$led accblink

# remount read/write
mount -o remount,rw %root% / || error_exit

# stop sshd
test -x /etc/rc.d/init.d/ssh && /etc/rc.d/init.d/ssh stop
sleep 1

# unpack sshd
tar xpzf $update/update-files.tar.gz -C / || error_exit

# initialize sshd environment
test -x $local/setup/setup-sshd.sh && $local/setup/setup-sshd.sh

finalize

# LED nomal
$led accon
sleep 1
$led acchw

exit 0
